/* LocaleInformation.java --
   Copyright (C) 2005  Free Software Foundation, Inc.

This file is part of GNU Classpath.

GNU Classpath is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

GNU Classpath is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU Classpath; see the file COPYING.  If not, write to the
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307 USA.

Linking this library statically or dynamically with other modules is
making a combined work based on this library.  Thus, the terms and
conditions of the GNU General Public License cover the whole
combination.

As a special exception, the copyright holders of this library give you
permission to link this library with independent modules to produce an
executable, regardless of the license terms of these independent
modules, and to copy and distribute the resulting executable under
terms of your choice, provided that you also meet, for each linked
independent module, the terms and conditions of the license of that
module.  An independent module is a module which is not derived from
or based on this library.  If you modify this library, you may extend
this exception to your version of the library, but you are not
obligated to do so.  If you do not wish to do so, delete this
exception statement from your version. */


// This file was automatically generated by gnu.localegen from LDML

package gnu.java.locale;

import java.util.Enumeration;
import java.util.Hashtable;
import java.util.StringTokenizer;
import java.util.ListResourceBundle;

public class LocaleInformation extends ListResourceBundle
{
  private static final String currenciesDisplayNameKeys = "INR\u00A6JPY\u00A6ITL\u00A6EUR\u00A6GBP\u00A6USD";

  private static final String currenciesDisplayNameValues = "INR\u00A6JPY\u00A6ITL\u00A6EUR\u00A6GBP\u00A6USD";

  private static final Hashtable currenciesDisplayName;
  static
  {
    currenciesDisplayName = new Hashtable();
    Enumeration keys = new StringTokenizer(currenciesDisplayNameKeys, "\u00A6");
    Enumeration values = new StringTokenizer(currenciesDisplayNameValues, "\u00A6");
    while (keys.hasMoreElements())
      {
         String key = (String) keys.nextElement();
         String value = (String) values.nextElement();
         currenciesDisplayName.put(key, value);
      }
  }

  private static final String currenciesSymbolKeys = "INR\u00A6JPY\u00A6ITL\u00A6EUR\u00A6GBP\u00A6USD";

  private static final String currenciesSymbolValues = "=0#Rs.|1#Re.|1<Rs.\u00A6\u00a5\u00A6\u20a4\u00A6\u20ac\u00A6\u00a3\u00A6$";

  private static final Hashtable currenciesSymbol;
  static
  {
    currenciesSymbol = new Hashtable();
    Enumeration keys = new StringTokenizer(currenciesSymbolKeys, "\u00A6");
    Enumeration values = new StringTokenizer(currenciesSymbolValues, "\u00A6");
    while (keys.hasMoreElements())
      {
         String key = (String) keys.nextElement();
         String value = (String) values.nextElement();
         currenciesSymbol.put(key, value);
      }
  }

  private static final String[] shortMonths = {
    "1",
    "2",
    "3",
    "4",
    "5",
    "6",
    "7",
    "8",
    "9",
    "10",
    "11",
    "12",
    null,
  };

  private static final String[] months = {
    "1",
    "2",
    "3",
    "4",
    "5",
    "6",
    "7",
    "8",
    "9",
    "10",
    "11",
    "12",
    null,
  };

  private static final String[] shortWeekdays = {
    null,
    "1",
    "2",
    "3",
    "4",
    "5",
    "6",
    "7",
  };

  private static final String[] weekdays = {
    null,
    "1",
    "2",
    "3",
    "4",
    "5",
    "6",
    "7",
  };

  private static final String[] eras = {
    "BCE",
    "CE",
  };

  private static final String[] ampms = {
    "AM",
    "PM",
  };


  private static final Object[][] contents =
  {
    { "percent", "%" },
    { "perMill", "\u2030" },
    { "exponential", "E" },
    { "infinity", "\u221e" },
    { "NaN", "\ufffd" },
    { "minusSign", "-" },
    { "zeroDigit", "0" },
    { "decimalSeparator", "." },
    { "groupingSeparator", "," },
    { "digit", "#" },
    { "percentFormat", "#,##0%" },
    { "currencyFormat", "\u00a4 #,##0.00;-\u00a4 #,##0.00" },
    { "localPatternChars", "GyMdkHmsSEDFwWahKzYeugAZ" },
    { "currenciesDisplayName", currenciesDisplayName },
    { "currenciesSymbol", currenciesSymbol },
    { "shortMonths", shortMonths },
    { "months", months },
    { "shortWeekdays", shortWeekdays },
    { "weekdays", weekdays },
    { "minNumberOfDaysInFirstWeek", "1" },
    { "firstDayOfWeek", "sun" },
    { "eras", eras },
    { "ampms", ampms },
    { "shortDateFormat", "yy/MM/dd" },
    { "mediumDateFormat", "yyyy MMM d" },
    { "longDateFormat", "yyyy MMMM d" },
    { "fullDateFormat", "EEEE, yyyy MMMM dd" },
    { "shortTimeFormat", "HH:mm" },
    { "mediumTimeFormat", "HH:mm:ss" },
    { "longTimeFormat", "HH:mm:ss z" },
    { "fullTimeFormat", "HH:mm:ss z" },
  };

  public Object[][] getContents() { return contents; }
}
